<?php

class JobAddEdit
{
	public static $tabs;

    public static function init(){

		do_action( 'job-postings/add-edit-loaded');

		self::$tabs = array(
			'job_form' => _x('Position details', 'job-meta-box', 'job-postings'),
			'job_settings' => _x('Settings', 'job-meta-box', 'job-postings'),
			'job_confirmation' => _x('Confirmation', 'job-meta-box', 'job-postings'),
			'job_notification' => _x('Notification', 'job-meta-box', 'job-postings'),
		);
		
		self::$tabs = apply_filters('job-postings/job-tabs', self::$tabs);
		
		add_action( 'add_meta_boxes', array('JobAddEdit', 'add_meta_boxes'), 10, 2 );
		add_action( 'save_post', array('JobAddEdit', 'save') );
	}

    public static function add_meta_boxes(){

        add_meta_box(
            'jobs-postings-meta-box',
            __( 'Position details', 'job-postings' ),
            array('JobAddEdit', 'render_job_fileds_metabox'),
            'jobs',
            'normal',
            'high'
        );

        add_meta_box(
            'jobs-postings-disabled-meta-box',
            __( 'Inactive widgets', 'job-postings' ),
            array('JobAddEdit', 'render_job_disabled_fields_metabox'),
            'jobs',
            'side',
            'default'
        );
    }


    public static function render_job_disabled_fields_metabox( $post ){

        switch (Job_Postings::$side_position) {
            case 'left':
                $append_class_1 = 'jobs-wrapper-sortable-right';
                $append_class_2 = 'jobs-wrapper-sortable-left';
                break;

            default:
                $append_class_1 = 'jobs-wrapper-sortable-left';
                $append_class_2 = 'jobs-wrapper-sortable-right';
                break;
        }

        echo '<div class="jobs-wrapper menu-instructions-inactive jobs-wrapper-disabled jobs-wrapper-sortable-disabled connectedSortable" data-sort="sort-disabled">';
            self::renderFields( 'sort-disabled', Job_Postings::$fields, $post, $append_class_1, $append_class_2 );
        echo '</div>';
	}
	

	public static function add_tabs(){
		if( !empty(self::$tabs) && is_array(self::$tabs) ){
			$out = '';
			foreach( self::$tabs as $id => $name ){
				$current = '';
				if($id == 'job_form') $current = 'current';
				$out .= '<li class=""><a href="#'.$id.'" class="'.$current.'">'.$name.'</a> </li>';
			}
			return $out;
		}
	}


    public static function render_job_fileds_metabox( $post ){

        wp_nonce_field( 'job_postings_meta_box_nonce', 'jp-meta_box_nonce' );

		$post_id = $post->ID;

        $out = '<div class="job_tabs">';
        $out .= '<div class="wp-filter">';
            $out .= '<ul class="job_tab filter-links">';
				$out .= self::add_tabs();
			$out .= '</ul>';
        $out .= '</div>';

        switch (Job_Postings::$side_position) {
            case 'left':
                $append_class_1 = 'jobs-wrapper-sortable-right';
                $append_class_2 = 'jobs-wrapper-sortable-left';

                $class_1 		= 'jobs-wrapper-right jobs-wrapper-sortable-right';
                $class_2 		= 'jobs-wrapper-left jobs-wrapper-sortable-left';

                $sort_type_1 	= 'sort-right';
                $sort_type_2 	= 'sort-left';
                break;

            default:
                $append_class_1 = 'jobs-wrapper-sortable-left';
                $append_class_2 = 'jobs-wrapper-sortable-right';

                $class_1 		= 'jobs-wrapper-left jobs-wrapper-sortable-left';
                $class_2 		= 'jobs-wrapper-right jobs-wrapper-sortable-right';

                $sort_type_1 	= 'sort-left';
                $sort_type_2 	= 'sort-right';
                break;
        }

		echo $out;

		if( !empty(self::$tabs) && is_array(self::$tabs) ){
			$out = '';
			foreach( self::$tabs as $id => $name ){
				switch($id){
					case 'job_form':
						echo '<div id="job_form" class="job_tab_content clearfix '.$sort_type_2.'">';
							echo '<div class="jobs-wrapper menu-instructions-inactive jobs_match_height '.$class_1.' connectedSortable" data-sort="'.$sort_type_1.'">';
								self::renderFields( $sort_type_1, Job_Postings::$fields, $post, $append_class_1, $append_class_2 );
							echo '</div>';
							echo '<div class="jobs-wrapper menu-instructions-inactive jobs_match_height '.$class_2.' connectedSortable" data-sort="'.$sort_type_2.'">';
								self::renderFields( $sort_type_2, Job_Postings::$fields, $post, $append_class_1, $append_class_2 );
							echo '</div>';
						echo '</div>';
						echo '<div class="clearfix" style="clear:both"></div>';
					break;

					case 'job_settings':
						echo '<div id="job_settings" class="job_tab_content" style="display: none;">';
							echo '<div class="jobs-wrapper">';
								include_once( JOBPOSTINGSPATH . 'include/views/job-settings.php');
							echo '</div>';
						echo '</div>';
					break;

					case 'job_confirmation':
						echo '<div id="job_confirmation" class="job_tab_content" style="display: none;">';
							echo '<div class="jobs-wrapper">';
								include_once( JOBPOSTINGSPATH . 'include/views/job-confirmation.php');
							echo '</div>';
						echo '</div>';
					break;
					
					case 'job_notification':
						echo '<div id="job_notification" class="job_tab_content" style="display: none;">';
							echo '<div class="jobs-wrapper">';
								include_once( JOBPOSTINGSPATH . 'include/views/job-notification.php');
							echo '</div>';
						echo '</div>';
					break;

					default:
						echo '<div id="'.$id.'" class="job_tab_content" style="display: none;">';
							echo '<div class="jobs-wrapper">';
								do_action("job-postings/custom-tab-{$id}", $post_id, $post);
							echo '</div>';
						echo '</div>';
					break;
				}
			}
		}
            

        echo '</div>';
    }



    public static function renderFields( $position = 'sort-left', $fields, $post, $append_class_1 = '', $append_class_2 = ''  ){
    	global $pagenow, $typenow;
		$post_id 	= $post->ID;

		$adding_new_job = false;
		if (in_array( $pagenow, array( 'post-new.php' ) ) && "jobs" == $typenow){
			$adding_new_job = true;
		}

    	$post_id 	= $post->ID;

    	if( $fields ){

    		$fields_copy = $fields;


			$tpl = '';

			$tpl .= '<input type="file" name="{key}" id="{key}" class="inputfile inputfile-6" />';
			$tpl .= '<label for="{key}"><span>{filename}</span> <strong><svg xmlns="http://www.w3.org/2000/svg" width="20" height="17" viewBox="0 0 20 17"><path d="M10 0l-5.2 4.9h3.3v5.1h3.8v-5.1h3.3l-5.2-4.9zm9.3 11.5l-3.2-2.1h-2l3.4 2.6h-3.5c-.1 0-.2.1-.2.1l-.8 2.3h-6l-.8-2.2c-.1-.1-.1-.2-.2-.2h-3.6l3.4-2.6h-2l-3.2 2.1c-.4.3-.7 1-.6 1.5l.6 3.1c.1.5.7.9 1.2.9h16.3c.6 0 1.1-.4 1.3-.9l.6-3.1c.1-.5-.2-1.2-.7-1.5z"/></svg> Choose a file...</strong></label>';

   		 	$script = '<script type="x-tmpl-mustache" id="file-upload-tpl">';
   		 		$script .= $tpl;
   		 	$script .= '</script>';

   		 	echo $script;

	   		// SORT
	   		foreach ($fields as $index => $field) {
    			$name 		= isset($field['name']) ? $field['name'] : '';
    			$key 		= isset($field['key']) ? $field['key'] : false;
    			if( !$key ) continue;

    			if( !$adding_new_job ){
				    $sort_index = get_post_meta( $post_id, 'sort-'.$key, true );

				    if( !$sort_index ) $sort_index = $fields[$index]['sort'];
				}else{
					$sort_index = $fields[$index]['sort'];
				}

			    if( strpos($sort_index, $position) === false ){
			    	unset( $fields[$index] );
			    	continue;
			    }

			    $sort_index = str_replace($position.'-', '', $sort_index);

			    if( $sort_index == '' || $sort_index == 'sort-disabled' || $sort_index == 'sort-right' || $sort_index == 'sort-left' ) $sort_index = $index;

			    $fields[$index]['sort'] = $sort_index;

	   		}

	   		/*
	   		print_r('<pre>');
	   		print_r($fields);
	   		print_r('</pre>');
	   		die();
	   		*/


	   		if(!$adding_new_job) usort($fields, array('Job_Postings_Helper','sortByOrder') );

	   		// RENDER
    		foreach ($fields as $index => $field) {


    			$value 		= '';
    			$type 		= isset($field['type']) ? $field['type'] : 'input';
    			$name 		= isset($field['name']) ? $field['name'] : 'Field';
    			$need 		= isset($field['need']) ? $field['need'] : 0;
    			$key 		= isset($field['key']) ? $field['key'] : false;
    			$required 	= isset($field['required']) ? $field['required'] : false;

    			$placeholder 		= isset($field['placeholder']) ? $field['placeholder'] : '';
    			$placeholder_st 	= isset($field['placeholder_st']) ? $field['placeholder_st'] : '';
    			$placeholder_al 	= isset($field['placeholder_al']) ? $field['placeholder_al'] : '';
    			$placeholder_ar 	= isset($field['placeholder_ar']) ? $field['placeholder_ar'] : '';
    			$placeholder_cc 	= isset($field['placeholder_cc']) ? $field['placeholder_cc'] : '';
    			$placeholder_zip 	= isset($field['placeholder_zip']) ? $field['placeholder_zip'] : '';
    			$placeholder_btn 	= isset($field['placeholder_btn']) ? $field['placeholder_btn'] : '';

    			$options 	= isset($field['options']) ? $field['options'] : array();
    			$teeny 		= isset($field['teeny']) ? $field['teeny'] : false;
    			$description = isset($field['description']) ? $field['description'] : false;

    			$teeny 		= apply_filters('jobs-postings/tinymce_teeny', $teeny);

    			if( !$key ) continue;

				$values = get_post_custom( $post_id );
				
				switch($need){
					case 1:
						$need_text = _x('Required', 'jobs-field', 'job-postings');
						$need_class = 'jobs-field-required';
					break;

					case 2:
						$need_text = _x('Recommended', 'jobs-field', 'job-postings');
						$need_class = 'jobs-field-recommended';
					break;

					default:
						$need_text = '';
						$need_class = '';
					break;
				}

				if( $need_text ) $need_text = '<span class="jobs-field-need-by-g '.$need_class.'" title="by Google">'.$need_text.'</span>';


				$currency_symbol = get_option( 'jobs_currency_symbol'.'_'.Job_Postings::$lang );
				if(!$currency_symbol) $currency_symbol = '€';

			    $req 		= $required ? 'required' : '';
			    $req_star 	= $required ? ' *' : '';

			    $dir = plugin_dir_url(__FILE__).'../';

    			echo '<div class="jobs-row clearfix type-'.$type.'">';
    				echo '<div class="jobs-row-label">';
    					echo '<img class="jobs-sort-icon" src="'.$dir.'/images/sort.svg" width="15" title="Grab and sort">';
		   		 		echo '<label for="'.$key.'">'.$name.$need_text.'</label>';

						echo '<img class="jobs-remove-icon" src="'.$dir.'/images/bin.svg" width="15" title="Disable field">';

		   		 		if( $type != 'empty_apply_now' ) echo '<img class="jobs-gear-icon" src="'.$dir.'/images/gear.svg" width="15" title="Settings">';


						echo '<img class="jobs-setright" data-append="'.$append_class_2.'" src="'.$dir.'/images/set-right.svg" width="15" title="Add to left column">';
						echo '<img class="jobs-setleft" data-append="'.$append_class_1.'" src="'.$dir.'/images/set-left.svg" width="15" title="Add to right column">';

					echo '</div>';

		   		 	echo self::renderFieldSettings( $post_id, $key );

		   		 	echo '<div class="jobs-row-input">';

		   		 	if( $description ){
		   		 		echo '<p class="jobs-field-description">'.$description.'</p>';
		   		 	}

				    echo '<input class="item-sort-value" type="hidden" name="sort-'.$key.'" value="'.$index.'"/>';

    			switch ( $type ) {

    				case 'empty_hiring_logo':
    					# INPUT

							$company_logo 			= get_option('jobs_company_logo');

							if( $company_logo ){
								$hiring_organization 	= get_option('jobs_hiring_organization'.'_'.Job_Postings::$lang);
								if(!$hiring_organization) $hiring_organization = get_option('blogname');
								$out = '<img class="jobs_hiring_logo" src="'.$company_logo.'" alt="'.$hiring_organization.'" title="'.$hiring_organization.'">';
							}else{
								$out = _x('Logo can be added/changed in <a target="_blank" href="edit.php?post_type=jobs&page=jp-help">Settings</a>.', 'job-settings', 'job-postings');
							}

				    		echo $out;
    					break;

    				case 'empty_date':
    					# INPUT
    						$job_date = get_the_date( get_option('date_format'), $post_id );
				    		echo $job_date;
    					break;

    				case 'empty_pdf_export':
    					# INPUT

    						$value = isset( $values[$key] ) ? esc_attr( $values[$key][0] ) : '';

							$pdf_ico = '<img class="pdf-icon" src="'.plugin_dir_url( __FILE__ ).'../images/pdf.svg" width="15">';

							echo $pdf_ico. '<input class="jp-input inline-input" list="datalist-'.$key.'" autocomplete="off" type="text" name="'.$key.'" id="'.$key.'" value="'.$value.'" placeholder="'.$placeholder.'" '.$req.'/>';
    					break;

    				case 'empty_apply_now':
    					# INPUT

    						$value = isset( $values[$key] ) ? esc_attr( $values[$key][0] ) : $name;

				    		echo '<input class="jp-input" autocomplete="off" type="text" name="'.$key.'" id="'.$key.'" value="'.$value.'" placeholder="'.$placeholder.'" '.$req.'/>';
				    		//echo '<p>'.$placeholder.'</p>';
    					break;

    				case 'empty_inline_apply_now':
    					# INPUT

    						$value = isset( $values[$key] ) ? esc_attr( $values[$key][0] ) : $name;

				    		//echo '<input class="jp-input" autocomplete="off" type="text" name="'.$key.'" id="'.$key.'" value="'.$value.'" placeholder="'.$placeholder.'" '.$req.'/>';
				    		//echo '<p>'.$placeholder.'</p>';
    					break;

    				case 'custom_button':
    					# INPUT

    						$value = isset( $values[$key] ) ? strip_tags( $values[$key][0] ) : $name;
			    			$style 	= isset( $values[$key.'-style'] ) ? esc_attr( $values[$key.'-style'][0] ) : 'primary-style';

				    		echo '<input class="jp-input '.$style.'" autocomplete="off" type="text" name="'.$key.'" id="'.$key.'" value="'.$value.'" placeholder="'.$placeholder.'" '.$req.'/>';
				    		//echo '<p>'.$placeholder.'</p>';
    					break;

    				case 'valid_through':
    					# INPUT

    						$value = isset( $values[$key] ) ? esc_attr( $values[$key][0] ) : '';

				    		echo '<input class="jp-input js-datepicker" autocomplete="off" type="text" name="'.$key.'" id="js-datepicker" value="'.$value.'" placeholder="'.$placeholder.'" '.$req.'/>';
				    		//echo '<p>'.$placeholder.'</p>';
    					break;


    				case 'textarea':
    					# INPUT
    						$value = isset( $values[$key] ) ? $values[$key][0] : '';

				    		echo '<textarea class="jp-textarea" resize="none" rows="2" name="'.$key.'" id="'.$key.'" placeholder="'.$placeholder.'" '.$req.'>'.$value.'</textarea>';
    					break;


    				case 'location':
    					# INPUT

							// Help switch
							echo Job_Postings_Helper::get_onoff_switch( __('Need help?', 'job-postings'), $key . '_help', '', false, 'wrap_job_location_help', '', false, 'empty help' );

							echo '<div id="wrap_job_location_help">';
								echo '<p class="jfw_hint">'.__('<b>Physical work on site only:</b> Input address location, but leave "Job is remote" switch off.', 'job-postings').'</p>';

								echo '<p class="jfw_hint">'.__('<b>Physical work on site OR remote within the same country:</b> Input address location and enable "Job is remote" switch.', 'job-postings').'</p>';

								echo '<p class="jfw_hint">'.__('<b>Remote work only:</b> Leave inputs below empty and enable "Job is remote" switch.', 'job-postings').'</p>';

								echo '<p class="jfw_hint">'.__('<b>Remote work only and limited to State/Country:</b> Leave inputs below empty, enable "Job is remote" switch and add geographical restrictions for where the remote work can be performed.', 'job-postings').'</p>';

								echo '<p class="jfw_hint">'.__('<b>Physical work on site OR remote with restrictions:</b> Input address location, enable "Job is remote" switch and add geographical restrictions for where the remote work can be performed.', 'job-postings').'</p>';
							echo '</div>';

							//print_r( $values );
							
							echo '<div id="wrap_job_location" class="wrap_job_location">';

								echo JobAddEdit::getDatalist( $key );
								echo JobAddEdit::getDatalist( $key . '_streetAddress' );
								echo JobAddEdit::getDatalist( $key . '_postalCode' );
								echo JobAddEdit::getDatalist( $key . '_addressLocality' );
								echo JobAddEdit::getDatalist( $key . '_addressRegion' );

								$streetAddress = isset( $values[$key.'_streetAddress'] ) ? esc_attr( $values[$key.'_streetAddress'][0] ) : '';
								echo '<input class="jp-input" list="datalist-'.$key.'_streetAddress" autocomplete="off" type="text" name="'.$key.'_streetAddress" id="'.$key.'_streetAddress" value="'.$streetAddress.'" placeholder="'.$placeholder_st.'" />';


								$postalCode = isset( $values[$key.'_postalCode'] ) ? esc_attr( $values[$key.'_postalCode'][0] ) : '';
								echo '<input class="jp-input" list="datalist-'.$key.'_postalCode" autocomplete="off" type="text" name="'.$key.'_postalCode" id="'.$key.'_postalCode" value="'.$postalCode.'" placeholder="'.$placeholder_zip.'" />';


								$city = isset( $values[$key] ) ? esc_attr( $values[$key][0] ) : '';
								echo '<input class="jp-input" list="datalist-'.$key.'" autocomplete="off" type="text" name="'.$key.'" id="'.$key.'" value="'.$city.'" placeholder="'.$placeholder.'" '.$req.'/>';


								// $addressLocality = isset( $values[$key.'_addressLocality'] ) ? esc_attr( $values[$key.'_addressLocality'][0] ) : '';
								// echo '<input class="jp-input" list="datalist-'.$key.'_addressLocality" autocomplete="off" type="text" name="'.$key.'_addressLocality" id="'.$key.'_addressLocality" value="'.$addressLocality.'" placeholder="'.$placeholder_al.'" />';


								$addressRegion = isset( $values[$key.'_addressRegion'] ) ? esc_attr( $values[$key.'_addressRegion'][0] ) : '';
								echo '<input class="jp-input" list="datalist-'.$key.'_addressRegion" autocomplete="off" type="text" name="'.$key.'_addressRegion" id="'.$key.'_addressRegion" value="'.$addressRegion.'" placeholder="'.$placeholder_ar.'" />';

								$addressCountry = isset( $values[$key.'_addressCountry'] ) ? esc_attr( $values[$key.'_addressCountry'][0] ) : '';
								echo '<input class="jp-input" list="datalist-'.$key.'_addressCountry" autocomplete="off" type="text" name="'.$key.'_addressCountry" id="'.$key.'_addressCountry" value="'.$addressCountry.'" placeholder="'.$placeholder_cc.'" />';

							echo '</div>';


							// Remote job switch
							echo Job_Postings_Helper::get_onoff_switch( __('Job is remote', 'job-postings'), $key . '_remote', '', false, 'wrap_job_location_remote' );

							$job_remote_data = get_post_meta($post_id, 'job_remote_data', true);


							// Remote job fields
							echo '<div id="wrap_job_location_remote" class="wrap_job_location_remote">';
								echo '<h4>'.__('Remote job restrictions', 'job-postings').'</h4>';

								echo '<p class="jfw_hint">'.__('You can add geographical restrictions for where the remote work can be performed. (Optional)', 'job-postings').'</p>';

								echo '<div class="jfw_repeater job_remote_repeater">';
									echo '<div class="jfw_sortable" data-repeater-list="job_remote_data">';

									if( !empty($job_remote_data) && is_array($job_remote_data) ){
									foreach ($job_remote_data as $key => $value) {
										echo '<div class="jfw_repeater_row clearfix" data-repeater-item>';

											$val = isset($job_remote_data[$key]['type']) ? $job_remote_data[$key]['type'] : '';
											echo '<label for="type-field-'.$key.'">'.__('Type', 'job-postings').'</label>';
											echo '<select id="type-field-'.$key.'" name="type" class="job_remote_data_type" data-hint-country="'.__('Example: USA').'" data-hint-state="'.__('Example: Texas, USA').'">';
												echo '<option value="">-</option>';
												echo '<option value="Country" '.selected($val, 'Country', false).'>Country</option>';
												echo '<option value="State" '.selected($val, 'State', false).'>State</option>';
											echo '</select>';

											$val2 = isset($job_remote_data[$key]['name']) ? $job_remote_data[$key]['name'] : '';
											echo '<label for="name-field-'.$key.'">'.__('Location', 'job-postings').'<span class="example"></span></label>';
											echo '<input id="name-field-'.$key.'" class="job-input-field job_remote_data_name" name="name" type="text" value="'.$val2.'">';

											echo '<input data-repeater-delete type="button" class="button button-delete" value="Delete"/>';
										echo '</div>';
									}
									}else{
										echo '<div class="jfw_repeater_row clearfix" data-repeater-item>';
											echo '<label for="type-field-">'.__('Type', 'job-postings').'</label>';
											echo '<select id="type-field-" name="type" class="job_remote_data_type" data-hint-country="'.__('Example: USA').'" data-hint-state="'.__('Example: Texas, USA').'">';
												echo '<option value="">-</option>';
												echo '<option value="Country">Country</option>';
												echo '<option value="State">State</option>';
											echo '</select>';

											echo '<label for="name-field-">'.__('Location', 'job-postings').'<span class="example"></span></label>';
											echo '<input id="name-field-" class="job-input-field job_remote_data_name" name="name" type="text" value="">';

											echo '<input data-repeater-delete type="button" class="button button-delete" value="Delete"/>';
										echo '</div>';
									}

									echo '</div>';
									echo '<input data-repeater-create type="button" class="button button-primary hg_addRemove" value="+"/>';
								echo '</div>';
							echo '</div>';

    					break;



    				case 'tinymce':
    					# INPUT
    						$value = isset( $values[$key] ) ? $values[$key][0] : '';

				    		wp_editor( $value, $key, array(
    							'textarea_rows' => 5,
    							'teeny' => $teeny
    							) );
    					break;



    				case 'file':
    					# INPUT
    						$num = 1;

					    	$html = '<div class="file-upload-list" data-num="1">';
    							$html .= '<div class="file-upload-item">';
		    						$value 	= isset( $values[$key] ) ? $values[$key][0]: '';
		    						$btnname 	= isset( $values[$key.'_name'] ) ? $values[$key.'_name'][0]: '';



									$html .= '<input id="'.$key.'_upload_file" class="jp-input" type="text" size="36" name="'.$key.'" value="'.$value.'" placeholder="'.$placeholder.'" />';
									$html .= '<input id="'.$key.'_upload_button_name" class="jp-input" type="text" size="36" name="'.$key.'_name" value="'.$btnname.'" placeholder="'.$placeholder_btn.'" />';


									$html .= '<input id="'.$key.'_upload_file_button" class="button" type="button" value="'.__('Upload/Select file', 'job-postings').'" />';


								$html .= '</div>';

							$html .= '</div>';

							$html .= '<script type="text/javascript">
								jQuery(document).ready(function(){
									var '.$key.'_custom_uploader;
										jQuery("#'.$key.'_upload_file_button").click(function(e) {
											e.preventDefault();
											console.log("click");
											if ('.$key.'_custom_uploader) {
												'.$key.'_custom_uploader.open();
												return;
											}
											'.$key.'_custom_uploader = wp.media.frames.file_frame = wp.media({
												title: "Choose Image",
												button: {
													text: "Choose file"
												},
												multiple: false
											});
											'.$key.'_custom_uploader.on("select", function() {
												attachment = '.$key.'_custom_uploader.state().get("selection").first().toJSON();
												jQuery("#'.$key.'_upload_file").val(attachment.url);
												jQuery("#'.$key.'_upload_button_name").val(attachment.title);
											});
											'.$key.'_custom_uploader.open();

										});
								});
							</script>';

							echo $html;
    					break;



    				default:
    					# INPUT

    						$value 	= isset( $values[$key] ) ? esc_attr( $values[$key][0] ) : '';
    						$upto 	= isset( $values[$key.'_upto'] ) ? esc_attr( $values[$key.'_upto'][0] ) : '';

							$currency_before = '';
							$currency_after = '';

							$input_class = '';
							if( $key == 'position_base_salary' && $currency_symbol ){
								$currency_position = get_option( 'jobs_currency_position'.'_'.Job_Postings::$lang );
								if(!$currency_position) $currency_position = 'before';

								switch ($currency_position) {
									case 'after':
										$symbol = '';
										$symbol .= '<span class="jobs-currency right-align">';
											$symbol .= $currency_symbol;
										$symbol .= '</span>';
										$currency_after = $symbol;
										$input_class = 'currency-in-right';
										break;

									default:
										$symbol = '';
										$symbol .= '<span class="jobs-currency left-align">';
											$symbol .= $currency_symbol;
										$symbol .= '</span>';
										$currency_before = $symbol;
										$input_class = 'currency-in-left';
										break;
								}

								echo '<div class="job-input-field-wrap">';
									// list="datalist-'.$key.'"
									echo '<label>' . _x('Starting', 'jobs-field', 'job-postings') . ':</label>';
									echo $currency_before;
						    		echo '<input class="jp-input '.$input_class.'" autocomplete="off" type="text" name="'.$key.'" id="'.$key.'" value="'.$value.'" placeholder="'.$placeholder.'" '.$req.'/>';
									echo $currency_after;
								echo '</div>';


								echo '<div class="job-input-field-wrap">';
									echo '<label>' . _x('Up to', 'jobs-field', 'job-postings') . ':</label>';
									echo $currency_before;
						    		echo '<input class="jp-input '.$input_class.'" autocomplete="off" type="text" name="'.$key.'_upto" id="'.$key.'_upto" value="'.$upto.'" placeholder="'.$placeholder.'" '.$req.'/>';
									echo $currency_after;
								echo '</div>';

					    		//echo  $this->getDatalist( $key );


							}else{
								echo $currency_before;
					    		echo '<input class="jp-input '.$input_class.'" list="datalist-'.$key.'" autocomplete="off" type="text" name="'.$key.'" id="'.$key.'" value="'.$value.'" placeholder="'.$placeholder.'" '.$req.'/>';
								echo $currency_after;

					    		echo  JobAddEdit::getDatalist( $key );
							}

    					break;
    			}

				    echo '</div>';

			    echo '</div>';


    		}

    	}


    }

    public static function renderFieldSettings( $post_id, $key ){
    	$out = '';

    	$out .= '<div class="jobs-row-settings">';

    		/* CUSTOM TITLE */
    		$out .= '<div class="field-settings-row">';

    			$name = $key.'-custom-title';
    			$value = get_post_meta($post_id, $name, true);

    			$out .= '<label for="'.$name.'">';
    				$out .= _x('Custom title', 'jobs-field', 'job-postings');
    			$out .= '</label>';
    			$out .= '<input id="'.$name.'" type="text" name="'.$name.'" value="'.$value.'">';
    		$out .= '</div>';
    		/**/

    		/* HIDE TITLE */
    		$out .= '<div class="field-settings-row">';

    			$name = $key.'-hide-title';
    			$value = get_post_meta($post_id, $name, true);

    			$out .= '<label for="'.$name.'">';
    				$out .= _x('Hide title', 'jobs-field', 'job-postings');
    			$out .= '</label>';
				//$out .= '<input id="'.$name.'" type="checkbox" name="'.$name.'" value="on" '.checked($value, 'on', false).'>';
				
				$out .= Job_Postings_Helper::get_onoff_switch( '', $name, '', false, '' );
    		$out .= '</div>';
    		/**/

    		/* HIDE FIELD */
				$out .= '<div class="field-settings-row">';

				$name = $key.'-hide-field';
				$value = get_post_meta($post_id, $name, true);

				$out .= '<label for="'.$name.'">';
					$out .= _x('Hide field', 'jobs-field', 'job-postings');
				$out .= '</label>';
				//$out .= '<input id="'.$name.'" type="checkbox" name="'.$name.'" value="on" '.checked($value, 'on', false).'>';
				
				$out .= Job_Postings_Helper::get_onoff_switch( '', $name, '', false, '' );

				$out .= '<p class="jobs-field-description clearfix">Only hides it from job offer on your site, but Google still sees and validates it. If you want complettely remove it, use "thash" icon in widgets top right corner.</p>';
			$out .= '</div>';
			/**/

    		switch ($key) {
    			case 'position_button':
    				$out .= '<div class="field-settings-row">';

		    			$name = $key.'-url';
		    			$value = get_post_meta($post_id, $name, true);

		    			$out .= '<label for="'.$name.'">';
		    				$out .= _x('URL', 'jobs-field', 'job-postings');
		    			$out .= '</label>';
    					$out .= '<input id="'.$name.'" type="text" name="'.$name.'" value="'.$value.'" placeholder="https://">';
		    		$out .= '</div>';

    				$out .= '<div class="field-settings-row">';

		    			$name = $key.'-url-target';
		    			$value = get_post_meta($post_id, $name, true);

		    			$out .= '<label for="'.$name.'">';
		    				$out .= _x('Link target', 'jobs-field', 'job-postings');
		    			$out .= '</label>';
		    			$out .= '<select id="'.$name.'" name="'.$name.'">';
		    				$out .= '<option value="_blank" '.selected($value, '_blank', false).'>'.__('New tab/window', 'jobs-field', 'job-postings').'</option>';
		    				$out .= '<option value="_self" '.selected($value, '_self', false).'>'.__('Same tab/window', 'jobs-field', 'job-postings').'</option>';
		    			$out .= '</select>';
		    		$out .= '</div>';

    				$out .= '<div class="field-settings-row">';

		    			$name = $key.'-style';
		    			$value = get_post_meta($post_id, $name, true);

		    			$out .= '<label for="'.$name.'">';
		    				$out .= _x('Style', 'jobs-field', 'job-postings');
		    			$out .= '</label>';
		    			$out .= '<select id="'.$name.'" name="'.$name.'">';
		    				$out .= '<option value="primary-style" '.selected($value, 'primary-style', false).'>'.__('Primary', 'jobs-field', 'job-postings').'</option>';
		    				$out .= '<option value="secondary-style" '.selected($value, 'secondary-style', false).'>'.__('Secondary', 'jobs-field', 'job-postings').'</option>';
		    			$out .= '</select>';
		    		$out .= '</div>';
    				break;

    			default:
    				# code...
    				break;
    		}


    	$out .= '</div>';

    	return $out;
    }


    public static function save( $post_id ){
        global $BlueGlassAnalytics;

        // Bail if we're doing an auto save
        if( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) return;

        // now we can actually save the data
        $allowed = array(
            'a' => array( // on allow a tags
                'href' => array() // and those anchors can only have href attribute
            ),
            'p'=> array(
                'style' => array()
            ),
            'br'=> array(),
            'b'=> array(),
            'strong'=> array(),
            'i'=> array(),
            'em'=> array(),
            'u'=> array(),
            'ul'=> array(),
            'ol'=> array(),
            'li'=> array(),
            'span'=> array(
                'style' => array()
            ),
            'img' => array(
                    'src' => array(),
                    'width' => array(),
                    'height' => array(),
                    'class' => array(),
                )
        );

        // if our nonce isn't there, or we can't verify it, bail
        if( !isset( $_POST['jp-meta_box_nonce'] ) || !wp_verify_nonce( sanitize_text_field( $_POST['jp-meta_box_nonce'] ), 'job_postings_meta_box_nonce' ) ) return;

        // if our current user can't edit this post, bail
		if( !current_user_can( 'edit_posts' ) ) return;
		

		$_POST = apply_filters('job-postings/modify_request', $_POST);


        if( isset( $_POST['job_custom_message'] ) ){
            $notification_message = wp_kses( $_POST['job_custom_message'], $allowed );
            update_post_meta( $post_id, 'job_custom_message', $notification_message );
        }

        if( isset( $_POST['job_notification_message'] ) ){
            $notification_message = wp_kses( $_POST['job_notification_message'], $allowed );
            update_post_meta( $post_id, 'job_notification_message', $notification_message );
		}
		
		/* Custom notificaton fields */

		// On/Off switch
		$value = isset( $_POST['job_notify_custom_message'] ) ? strip_tags( $_POST['job_notify_custom_message'] ) : '';
		update_post_meta( $post_id, 'job_notify_custom_message', $value );
	
		// Editor text
		$notify_custom_message = isset( $_POST['job_notify_custom_message_editor'] ) ? $_POST['job_notify_custom_message_editor'] : '';
		update_post_meta( $post_id, 'job_notify_custom_message_editor', $notify_custom_message );

		/* - */

        if( isset( $_POST['job_confirmation_email'] ) ){
            $confirmation_email = strip_tags( $_POST['job_confirmation_email'] );

            if (strpos($confirmation_email, ',') !== false) {
                $confirmation_emails = explode(',', $confirmation_email);
                if(!empty($confirmation_emails)){
                    $sanitized_emails = array();
                    foreach ($confirmation_emails as $key => $email) {
                        $sanitized_emails[] = sanitize_email( $email );
                    }
                    $confirmation_email = implode(',',$sanitized_emails);
                }
            }else{
                $confirmation_email = sanitize_email( $_POST['job_confirmation_email'] );
            }

            update_post_meta( $post_id, 'job_confirmation_email', $confirmation_email );
        }



        $fields = Job_Postings::$fields;
        if( $fields ){

            //print_r( $_POST );

            foreach ($fields as $index => $field) {

                $type 	= isset($field['type']) ? $field['type'] : 'input';
                $key 	= isset($field['key']) ? $field['key'] : false;

                // continue if key is missing
                if( !$key ) continue;

                if( isset( $_POST[$key] ) ){
                    $field_key = wp_kses( $_POST[$key], $allowed );
                    update_post_meta( $post_id, $key, $field_key );
                }

                if( isset( $_POST['sort-'.$key] ) ){
                    $field_sort_key = sanitize_title( $_POST['sort-'.$key] );
                    update_post_meta( $post_id, 'sort-'.$key, sanitize_text_field($field_sort_key) );
                }

                if( isset( $_POST[$key . '-custom-title'] ) ){
                    $field_key_title = sanitize_text_field( $_POST[$key . '-custom-title'] );
                    update_post_meta( $post_id, $key . '-custom-title', sanitize_text_field($field_key_title) );
                }


                $hide_title = isset($_POST[$key . '-hide-title']) ? 'on':'off';
                update_post_meta( $post_id, $key . '-hide-title', sanitize_text_field($hide_title) );

                $hide_title = isset($_POST[$key . '-hide-field']) ? 'on':'off';
                update_post_meta( $post_id, $key . '-hide-field', sanitize_text_field($hide_title) );


                if( isset( $_POST[$key . '-url'] ) ){
                    $field_key_title = esc_url( $_POST[$key . '-url'] );
                    update_post_meta( $post_id, $key . '-url', $field_key_title );
                }

                if( isset( $_POST[$key . '-url-target'] ) ){
                    $field_key_title = sanitize_text_field( $_POST[$key . '-url-target'] );
                    update_post_meta( $post_id, $key . '-url-target', sanitize_text_field($field_key_title) );
                }


                if( isset( $_POST[$key . '-style'] ) ){
                    $field_key_title = sanitize_text_field( $_POST[$key . '-style'] );
                    update_post_meta( $post_id, $key . '-style', sanitize_text_field($field_key_title) );
                }

            }
        }



        if( isset( $_POST['position_base_salary_upto'] ) ){
            $field_key_title = sanitize_text_field( $_POST['position_base_salary_upto'] );
            update_post_meta( $post_id, 'position_base_salary_upto', sanitize_text_field($field_key_title) );
        }


        if( isset( $_POST['position_pdf_job_name'] ) ){
            $field_key_title = sanitize_text_field( $_POST['position_pdf_job_name'] );
            update_post_meta( $post_id, 'position_pdf_job_name', sanitize_text_field($field_key_title) );
		}
		
		//position_job_location_remote
		// Remote Job On/Off switch
		$value = isset( $_POST['position_job_location_remote'] ) ? strip_tags( $_POST['position_job_location_remote'] ) : '';
		update_post_meta( $post_id, 'position_job_location_remote', $value );

		//type
		$job_remote_data = isset( $_POST['job_remote_data'] ) ? $_POST['job_remote_data'] : '';
		update_post_meta( $post_id, 'job_remote_data', $job_remote_data );


        if( isset( $_POST['position_job_location_streetAddress'] ) ){
            $field_key_title = sanitize_text_field( $_POST['position_job_location_streetAddress'] );
            update_post_meta( $post_id, 'position_job_location_streetAddress', sanitize_text_field($field_key_title) );
        }
        if( isset( $_POST['position_job_location_postalCode'] ) ){

            //print_r( $_POST['position_job_location_postalCode'] );
            //die();

            $field_key_title = sanitize_text_field( $_POST['position_job_location_postalCode'] );
            update_post_meta( $post_id, 'position_job_location_postalCode', sanitize_text_field($field_key_title) );
		}
		// Save city as locality
		if( isset( $_POST['position_job_location'] ) ){
            $field_key_title = sanitize_text_field( $_POST['position_job_location'] );
            update_post_meta( $post_id, 'position_job_location_addressLocality', sanitize_text_field($field_key_title) );
        }
        // if( isset( $_POST['position_job_location_addressLocality'] ) ){
        //     $field_key_title = sanitize_text_field( $_POST['position_job_location_addressLocality'] );
        //     update_post_meta( $post_id, 'position_job_location_addressLocality', sanitize_text_field($field_key_title) );
        // }
        if( isset( $_POST['position_job_location_addressRegion'] ) ){
            $field_key_title = sanitize_text_field( $_POST['position_job_location_addressRegion'] );
            update_post_meta( $post_id, 'position_job_location_addressRegion', sanitize_text_field($field_key_title) );
        }
        if( isset( $_POST['position_job_location_addressCountry'] ) ){
            $field_key_title = sanitize_text_field( $_POST['position_job_location_addressCountry'] );
            update_post_meta( $post_id, 'position_job_location_addressCountry', sanitize_text_field($field_key_title) );
        }


        // Update metrics data
        $metrics_counted = get_post_meta( $post_id, 'jobs_post_metrics_counted', true );
        $post_status = get_post_status( $post_id );

        if( $post_status == 'publish' && !$metrics_counted ){
            $active_jobs = get_option('jobs_metrics_active_postings');
            $active_jobs = $active_jobs + 1;

            update_option('jobs_metrics_active_postings', $active_jobs);
            update_post_meta( $post_id, 'jobs_post_metrics_counted', 'yes' );

            $BlueGlassAnalytics->track_metrics();
		}
		
		do_action('job-postings/save', $_POST, $post_id);


		
        $post_type  = get_post_type( $post_id );
        $updating 	= false;
        $post_parent = '';

        $archive_page = get_option('jobs_archive_page'.'_'.Job_Postings::$lang);

        switch ($post_type) {
            case 'jobs':
                $updating = true;
                $post_parent = $archive_page;
                break;

            default:
                $updating = false;
                break;
        }



        if( $updating ){
            // unhook this function so it doesn't loop infinitely
            remove_action( 'save_post', array('JobAddEdit', 'save'), 10, 2 );

            // update the post, which calls save_post again
            wp_update_post( array( 'ID' => $post_id, 'post_parent' => $post_parent ) );

            // re-hook this function
            add_action( 'save_post', array('JobAddEdit', 'save'), 10, 2 );
        }
    }


    public static function getDatalist( $key ){
    	global $wpdb;

		$table_name 	= $wpdb->prefix . "postmeta";
		$out	= '';
		$rows = $wpdb->get_results( "SELECT * FROM $table_name WHERE meta_key = '$key' AND meta_value != ''" );
		if( !empty($rows) ){
			$out .= '<datalist id="datalist-'.$key.'">';
				foreach ($rows as $key => $row) {
					$out .= '<option value="'.$row->meta_value.'" />';
				}
			$out .= '</datalist>';
			return $out;
		}

		return '';
    }

}