Number.prototype.clamp = function(min, max) {
	return Math.min(Math.max(this, min), max);
};

(function($){
	$.fn.filterFind = function(selector) {
        return this.find('*')         // Take the current selection and find all descendants,
                   .addBack()         // add the original selection back to the set
                   .filter(selector); // and filter by the selector.
    };

    $.fn.svgDraw = function(progress) {
        this.filterFind('path').each(function() {
            var pathLength = this.getTotalLength();
            $(this).css('strokeDasharray', pathLength + ' ' + pathLength);
            $(this).css('strokeDashoffset', pathLength * ((1 - progress)).clamp(0, 1));
        });

        return this;
    };

	$(document).ready(function(){

		if( $('#jobs-modal-form').length ){

			setTimeout(function(){
				$('.jobs-modal').removeClass('hide');
			}, 500);

			$('.jp-apply-button').click(function(e){
				e.preventDefault();

				$('body').addClass('jobs-modal-open');
				$('.jobs-modal').addClass('open');
			});

			$('.jobs-modal .modal-close').click(function(e){
				e.preventDefault();
				$(this).parents('.jobs-modal').removeClass('open');
				$('body').removeClass('jobs-modal-open');
			});

			$('.jobs-modal-content').each(function(k){


				$(this).find( '.inputfile' ).each(function(k){

					var label	 = this.nextElementSibling;
					var labelVal = label.innerHTML;

					$(this).change(function(e){

						validateSize(this, e, false);

						var fileName = '';
						if( this.files && this.files.length > 1 )
							fileName = ( this.getAttribute( 'data-multiple-caption' ) || '' ).replace( '{count}', this.files.length );
						else
							fileName = e.target.value.split( '\\' ).pop();

						if( fileName ){
							label.querySelector( 'span' ).innerHTML = fileName;
							var num = $(this).parents('.modal-input-fileinput').attr('data-files');
							num = Number(num) + 1;
							$(this).parents('.modal-input-fileinput').attr('data-files', num);
						}else{
							label.innerHTML = labelVal;
						}
					});

					$(this).focus(function(){ $(this).addClass('has-focus') });
					$(this).blur(function(){ $(this).removeClass('has-focus') });
				});

			});


			if( $('.choose_file_multi_add').length ){
				var i = 1;
				$('.choose_file_multi_add').click(function(e){
					e.preventDefault();

					var key_id = $(this).data('key');

					var parent = $(this).parents('.modal-input-fileinput');
					var input = $('#file-input-tpl-'+key_id).html();
					var label = $('#file-label-tpl-'+key_id).html();

					var id =  key_id + '-'+i;
					var key = key_id + '-key-'+i;

					input = input.replace( '{id}', id ).replace( '{id}', id ).replace( '{id}', id );
					input = input.replace( '{nr}', i ).replace( '{nr}', i ).replace( '{nr}', i );
					input = input.replace( '{key}', key ).replace( '{key}', key ).replace( '{key}', key );

					label = label.replace( '{id}', id ).replace( '{id}', id ).replace( '{id}', id );

					$(input).insertBefore( $('#'+key_id+' .choose_file_multi_add') );
					$(label).insertBefore( $('#'+key_id+' .choose_file_multi_add') );
					//parent.prepend( input );
					//parent.prepend( label );

					$('#'+id).change(function(e){
						var fileName = '';

						validateSize(this, e, true);

						if( this.files && this.files.length > 1 )
							fileName = ( this.getAttribute( 'data-multiple-caption' ) || '' ).replace( '{count}', this.files.length );
						else
							fileName = e.target.value.split( '\\' ).pop();


						if( fileName ){
							$('#label-'+id).find('span.name').text( fileName );
							var num = $(this).parents('.modal-input-fileinput').attr('data-files');
							num = Number(num) + 1;
							$(this).parents('.modal-input-fileinput').attr('data-files', num);
						}
					});


					$('.choose_file_multi .remove').click(function(e){
						e.preventDefault();
						var id = $(this).parents('.choose_file_multi').attr('id');
						id = id.replace('label-', 'jobgroup-');

						var num = $(this).parents('.modal-input-fileinput').attr('data-files');
						num = Number(num) - 1;
						$(this).parents('.modal-input-fileinput').attr('data-files', num);

						$('.'+id).remove();

						recalculateInputs();

						return false;
					});

					$('#'+id).click();

					recalculateInputs();

					i++;
				});
			}

			function validateSize(file, event, multifile) {

				//return true;

				var allowed 		= jpsd.max_filesize ? jpsd.max_filesize : 10; //Defaults to 10MB
				var validation 	= jpsd.validation.replace('%1$s', allowed);

        		var FileSize 		= file.files[0].size / 1024 / 1024; // in MB

				var validation_holder = $(file).parents('.jobs-modal-input').find('.validation');

				//console.log('file size', FileSize);
				//console.log('allowed', allowed );

        		if (FileSize > allowed) {

					if( file.files && file.files.length > 1 )
						fileName = ( file.getAttribute( 'data-multiple-caption' ) || '' ).replace( '{count}', file.files.length );
					else
						fileName = event.target.value.split( '\\' ).pop();

					validation = validation.replace('%2$s', fileName);

					if( multifile ){
						var label	 = file.nextElementSibling;
						$(label).remove();
					}else{
						var label	 = file.nextElementSibling;
						label.querySelector( 'span' ).innerHTML = '';
						$(file).val(''); //for clearing with Jquery
					}
					//console.log( validation );

					validation_holder.html( validation );

        		} else {
					//console.log('size OK');
					validation_holder.html( '' );
        		}
				recalculateInputs();
    		}

			function recalculateInputs(){
				if( $('.modal-input-fileinput.multiple .modal-input-multifile').length == 0 ){
					$('.disabled-file-placeholder').addClass('input-reqired');
				}else{
					$('.disabled-file-placeholder').removeClass('input-reqired');
				}
			}

			function validateEmail(email) {
			  	var re = /^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
			  	return re.test(email);
			}


			var sending_form = false;

			$('.progress-button .progress-circle').svgDraw(0);

			

			$("form#jobs-modal-form").submit(function(e){
				e.preventDefault();

				var self 		= this;
				var toreturn	= true;
				//var errors 		= [];

				$('#jobs-modal-form .input-reqired').each(function(){
					var value = $(this).val();

					var is_checked = false;

					if( $(this).hasClass('input-job_email') ){
						if( value == '' || !validateEmail(value) ){
							$(this).addClass('jobs-alert').parents('.jobs-modal-input').addClass('jobs-alert');
							toreturn = false;
							//errors.push( $(this) );
						}else{
							$(this).removeClass('jobs-alert').parents('.jobs-modal-input').removeClass('jobs-alert');
						}
					}else if( $(this).hasClass('modal-input-checkbox') ){
						var checkboxes_checked = 0;
						$(this).parents('.checkbox_field').find('input[type="checkbox"]').each(function(){
							var checked = $(this).prop('checked');
							if( checked == true ){
								checkboxes_checked++;
							}
						});

						if( checkboxes_checked == 0 ){
							$(this).addClass('jobs-alert').parents('.jobs-modal-input').addClass('jobs-alert');
							toreturn = false;
							//errors.push( $(this) );
						}else{
							$(this).removeClass('jobs-alert').parents('.jobs-modal-input').removeClass('jobs-alert');
						}

					}else if( $(this).hasClass('modal-input-radio') ){
						var checkboxes_checked = 0;
						$(this).parents('.radio_field').find('input[type="radio"]').each(function(){
							var checked = $(this).prop('checked');
							if( checked == true ){
								checkboxes_checked++;
							}
						});

						if( checkboxes_checked == 0 ){
							$(this).addClass('jobs-alert').parents('.jobs-modal-input').addClass('jobs-alert');
							toreturn = false;
							//errors.push( $(this) );
						}else{
							$(this).removeClass('jobs-alert').parents('.jobs-modal-input').removeClass('jobs-alert');
						}

					}else{
						if( value == '' ){
							$(this).addClass('jobs-alert').parents('.jobs-modal-input').addClass('jobs-alert');
							toreturn = false;
							//errors.push( $(this) );
						}else{
							$(this).removeClass('jobs-alert').parents('.jobs-modal-input').removeClass('jobs-alert');
						}
					}

				});

				//console.log(toreturn, sending_form, errors);

				if( toreturn && sending_form == false ){
					/*
					var progressBTN = $(self).find('.progress-button');
					progressBTN.addClass('loading');

		        	var progressCRCL = $(self).find('.progress-circle');
				    var progress = 0;

				    var intervalId = setInterval(function() {
				        progress += Math.random() * 0.5;
				        progressCRCL.svgDraw(progress);

				        if(progress >= 1) {
				            clearInterval(intervalId);
				        }
				    }, 200);
				    */

	 			    sending_form = true;
	 			   	$('.job-submit').hide();
				    $('.jobs-sending').show();

	 			    var formData 			= new FormData($("form#jobs-modal-form")[0]);
						var valid_holder 	= $(self).find('.jobs-submit-validation');
						valid_holder.html('');

				    $.ajax({
				    	type: 'POST',
				        url: jpsd.ajaxurl,
				        data: formData,
				        processData: false,
				        contentType: false,

				        success: function (data) {

		            	//clearInterval(intervalId);
		            	//progressCRCL.svgDraw(1);

		            	// Clear all smaces and newlines that can happen on response on some servers
		            	data = data.replace(/\s/g, "");

			            if( data == 'ok' ){

				            	//setTimeout(function(){
				            	//	$(self).find('.progress-button').addClass('success');
				            	//}, 500);

					        	//setTimeout(function(){
					        		$(self).slideUp();
					        		$('#job-apply-confirmation').slideDown();
					        	//}, 1000);

					        }else{
										data = data.split('|');
										//data = $.parseJSON(data);
										//console.log( 'isArray', data, $.isArray(data) );

										if( $.isArray(data) ){

											$(data).each(function(i){
												var msg = data[i].split('_').join(' ');
												valid_holder.append('<div class="jobs-submit-error-msg">'+msg+'</div>');
											});
										}
					        	//setTimeout(function(){
					        	//	$(self).find('.progress-button').addClass('error');
					        	//}, 500);

					        	//setTimeout(function(){
					        		$('.jobs-sending').hide();
											$('.job-submit').show();
											sending_form = false;
					        	//}, 1000);
					        }

			    			return false;
				        },
				    });


			    	return false;
				}

			    return false;
			});


			/*
			$('.progress-button').on('click', function() {
			    var $button = $(this);
			    $(this).addClass('loading');

			    var $progress = $(this).find('.progress-circle');
			    var progress = 0;
			    var intervalId = setInterval(function() {
			        progress += Math.random() * 0.5;
			        $progress.svgDraw(progress);

			        if(progress >= 1) {
			            clearInterval(intervalId);
			            //console.log("cleared interval");
			            $button.removeClass('loading');
			            if($button.attr('data-result') == "true") {
			                $button.addClass('success');
			            }
			            else {
			            		$button.addClass('error');
			            }

			        }
			    }, 300);

			    // Now that we finished, unbind
			    $(this).off('click');
			});
			*/


		} // end .jobs-modal length

	});


})(jQuery);
